#!/bin/bash
# -------------------------------------------------------------------------
# Kopiert eine kleinen Vorspann (ca. 50 Zeilen) und alle .java-Dateien, die
# im aktuellen Arbeitsverzeichnis liegen und deren Name nicht mit "Jut"
# endet, in eine Datei namens LiesMich.txt. Dabei werden nicht alle Zeilen
# kopiert, sondern nur die erste Zeile jeder Funktionsvereinbarung und die
# Kommentare dazu.
# -------------------------------------------------------------------------

AUSDAT="LiesMich.txt"

cat > $AUSDAT <<HERE_DOCUMENT_ENDE_MARKIERUNG
ben Sie zu programmieren indem Sie einige von etwa 40 Funktionen schreiben
und Ihre Lsungen sofort testen (mit vorgegebenen Testprogrammen), statt
Ihre Lsungen nur mit "Musterlsungen" zu vergleichen (die eventuell ganz
anders strukturiert sind als Ihre Lsungen).

In dieser Datei werden etwa 40 Klassenfunktionen (engl. static non-void
methods) ziemlich genau beschrieben. Sie sollen diese Funktionen (oder
zumindest einige davon) programmieren und Ihre Lsungen testen. Dazu
finden Sie im aktuellen Verzeichnis einige ntzliche Dateien:

1. Zu jeder Funktion namens FFF gibt es eine Datei namens UebFFF.java,
   in der eine Klasse namens UebFFF und darin die Funktion FFF verein-
   bart wird. Allerdings besteht der Rumpf der Funktion nur aus einer
   (syntaktisch korrekten, aber semantisch falschen) return-Anweisung:
   z.B. return -123; oder return "Fehler"; oder so hnlich. Sie sollen
   diese return-Anweisung durch einen sinnvollen Funktionsrumpf ersetzen.

2. Ausserdem gibt es zu jeder Funktion namens FFF ein JUnit-Testprogramm
   namens UebFFFJut.java, mit dem man die Funktion FFF testen kann. Dazu
   muss man nur
   - die Datei    UebFFFJut.java compilieren
   - die Datei    UebFFF.java    compilieren
   - das Programm UebFFFJut      starten.

   Die JUnit-Testprogramme setzen JUnit Version 3.8 voraus (und funktio-
   nieren NICHT mit den neueren Versionen ab 4.0).

   Normalerweise sollte es gengen, das JUnit-Testprogramm UebFFFJut.java
   ein einziges Mal zu compilieren, auch wenn Sie die Datei UebFFF.java
   mehrmals verbessern und erneut compilieren.

3. Noch ehe Sie die einsame return-Anweisung im Rumpf der Funktion FFF
   durch einen "richtigen Rumpf" ersetzt haben, knnen Sie die Datei
   UebFFF.java compilieren und die Funktion FFF testen (wie im vorigen
   Abschnitt 2. beschrieben). Natrlich wird das Testprogramm dann einen
   roten Balken und zahlreiche Fehler anzeigen.
   
   Entwickeln Sie Ihre Funktion FFF schrittweise: Programmieren Sie erst
   die einfachsten Sonderflle, dann ein paar weitere Flle etc. Nach jedem
   Schritt knnen Sie Ihre Teillsung wieder testen und prfen, ob das
   JUnit-Testprogramm weniger Fehler anzeigt als beim vorigen Test. Wenn
   das Testprogramm einen grnen Balken zeigt (und selbst keine Fehler ent-
   hlt), ist Ihre Lsung fr die Funktion FFF fertig.

4. Wenn Sie beim Testen einer Funktion FFF Fehler im vorgegebenen
   Testprogramm UebFFFJut.java oder andere Unstimmigkeiten finden,
   dann melden Sie sie bitte durch eine Email an grude@tfh-berlin.de.

5. Jede Funktion FFF ist mit einem Schwierigkeitsgrad gekennzeichnet
   (am Ende der ersten Zeile der Funktion, z.B. so: // **):
   // *    (leicht       zu programmieren)
   // **   (mittelschwer zu programmieren)
   // ***  (schwer       zu programmieren)

HERE_DOCUMENT_ENDE_MARKIERUNG


# Fuer alle Dateinamen dat im aktuellen Verzeichnis, die nicht mit
# "Jut.java" enden:
for dat in  `ls -I*Jut.java` ; do
   
   # Wenn der Dateiname dat mit "Ueb" beginnt und mit ".java" endet:
   if test ${dat#Ueb} != $dat  &&  test ${dat%'.java'} != $dat; then
      echo $dat;
      
      # Eine kleine "Trennzeile" in die AUSDAT schreiben:
      echo -e "\n**********\n" >> $AUSDAT
      
      # "Das Filet einer Datei" in die AUSDAT schreiben:
      cat $dat | sed /static/,/return/!d  | sed /return/d | sed /^$/d >> $AUSDAT
      
      # Erlaeuterungen zu den sed-Befehlen:
      # Def.: Eine "return-Zeile" ist eine Zeile, in der "return" vorkommt
      # sed /static/,/return/!d 
      # Loesche alle Zeilen ausser (!d not delete) denen zwischen einer
      # static- und einer return-Zeile (d.h. eine Funktionsvereinbarung)
      # sed /return/d
      # Loescht alle return-Zeilen
      # sed /^$/d
      # Loescht alle Leerzeilen
   fi

done

