// Datei UebDivModLLJut.java
/* ------------------------------------------------------------------------
Ein JUnit-Programm zum Testen der Funktionen divLL und modLL in
der Klasse UebDivModLL
(JUnit Version 3.8)
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse

public class UebDivModLLJut extends TestCase {
   // ---------------------------------------------------------------------
   static public Test suite() {
      return new TestSuite(UebDivModLLJut.class);
   } // suite
   // ---------------------------------------------------------------------
   public void test01() {
      assertEquals(+3, UebDivModLL.divLL(+7, +2));
   } // test01
   // ---------------------------------------------------------------------
   public void test02() {
      assertEquals(+1, UebDivModLL.modLL(+7, +2));
   } // test02
   // ---------------------------------------------------------------------
   public void test03() {
      assertEquals(-4, UebDivModLL.divLL(-7, +2));
   } // test03
   // ---------------------------------------------------------------------
   public void test04() {
      assertEquals(+1, UebDivModLL.modLL(-7, +2));
   } // test04
   // ---------------------------------------------------------------------
   public void test05() {
      assertEquals(-4, UebDivModLL.divLL(+7, -2));
   } // test05
   // ---------------------------------------------------------------------
   public void test06() {
      assertEquals(-1, UebDivModLL.modLL(+7, -2));
   } // test06
   // ---------------------------------------------------------------------
   public void test07() {
      assertEquals(+3, UebDivModLL.divLL(-7, -2));
   } // test07
   // ---------------------------------------------------------------------
   public void test08() {
      assertEquals(-1, UebDivModLL.modLL(-7, -2));
   } // test08
   // ---------------------------------------------------------------------
   public void test09() {
      for (int dnd=-10; dnd<=+10; dnd++) {
         // Einen Divisor 0 vermeiden:
         for (int dorP=1, dorN=-1; dorP<=+10; dorP++, dorN--) {
            // Mit positivem Divisor dorP:
            int divP = UebDivModLL.divLL(+dnd, dorP);
            int modP = UebDivModLL.modLL(+dnd, dorP);
            assertEquals(dnd, modP + (dorP*divP));

            // Mit negativem Divisor dorN:
            int divN = UebDivModLL.divLL(+dnd, dorN);
            int modN = UebDivModLL.modLL(+dnd, dorN);
            assertEquals(dnd, modN + (dorN*divN));
         }
      }
   } // test08
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      junit.awtui.TestRunner.run(UebDivModLLJut.class);
   } // main
   // ---------------------------------------------------------------------
} // class UebDivModLLJut
