// Datei UebDrehRumRJut.java
/* ------------------------------------------------------------------------
Ein JUnit-Programm zum Testen der Funktion DrehRumR in der Klasse UebDrehRumR
(JUnit Version 3.8)
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse
import java.util.Arrays;

public class UebDrehRumRJut extends TestCase {
   // ---------------------------------------------------------------------
   static public Test suite() {
      return new TestSuite(UebDrehRumRJut.class);
   } // suite
   // ---------------------------------------------------------------------
   public void test01() {
      int[] orig = {1, 2, 3, 4, 5};
      int[] kopi = {1, 2, 3, 4, 5};
      int[] soll = {5, 4, 3, 2, 1};
      int[] ist  = UebDrehRumR.DrehRumR(orig);

      assertTrue(Arrays.equals(orig, kopi));
      assertTrue(Arrays.equals(soll, ist));
   } // test01
   // ---------------------------------------------------------------------
   public void test02() {
      int[] orig = {1, 2};
      int[] kopi = {1, 2};
      int[] soll = {2, 1};
      int[] ist  = UebDrehRumR.DrehRumR(orig);

      assertTrue(Arrays.equals(orig, kopi));
      assertTrue(Arrays.equals(soll, ist));
   } // test02
   // ---------------------------------------------------------------------
   public void test03() {
      int[] orig = {1};
      int[] kopi = {1};
      int[] soll = {1};
      int[] ist  = UebDrehRumR.DrehRumR(orig);

      assertTrue(Arrays.equals(orig, kopi));
      assertTrue(Arrays.equals(soll, ist));
   } // test03
   // ---------------------------------------------------------------------
   public void test04() {
      int[] orig = {};
      int[] soll = {};
      int[] ist  = UebDrehRumR.DrehRumR(orig);

      // In diesem Sonderfall duerfen orig und ist identisch sein
      // (daraus koennen kaum Probleme entstehen)
      assertTrue(Arrays.equals(soll, ist));
   } // test04
   // ---------------------------------------------------------------------
   public void test05() {
      int[] orig = {-1, -1, -1, -1};
      int[] kopi = {-1, -1, -1, -1};
      int[] soll = {-1, -1, -1, -1};
      int[] ist  = UebDrehRumR.DrehRumR(orig);

      assertTrue(Arrays.equals(orig, kopi));
      assertTrue(Arrays.equals(soll, ist));
   } // test05
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      junit.awtui.TestRunner.run(UebDrehRumRJut.class);
   } // main
   // ---------------------------------------------------------------------
} // class UebDrehRumRJut
