// Datei UebKopiereFlachRJut.java
/* ------------------------------------------------------------------------
Ein JUnit-Programm zum Testen der Funktion KopiereFlachR in
der Klasse UebKopiereFlachR
(JUnit Version 3.8)
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse
import java.util.Arrays;

public class UebKopiereFlachRJut extends TestCase {
   // ---------------------------------------------------------------------
   static public Test suite() {
      return new TestSuite(UebKopiereFlachRJut.class);
   } // suite
   // ---------------------------------------------------------------------
   static private boolean istFlacheKopie(StringBuilder[] orig,
                                         StringBuilder[] kopi)
   {
      // Liefert true, wenn orig und kopie nicht identisch sind, sondern
      // kopi eine flache Kopie von orig ist.

      if (orig == kopi)               return false;
      if (orig.length != kopi.length) return false;

      for (int i=0; i<orig.length; i++) {
         if (orig[i] != kopi[i]) return false;
      }
      return true;
   } // istFlacheKopie
   // ---------------------------------------------------------------------
   StringBuilder a1 = new StringBuilder("Hallo");
   StringBuilder a2 = new StringBuilder("Wie geht's?");
   StringBuilder a3 = new StringBuilder("Gut!");
   StringBuilder a4 = new StringBuilder();
   StringBuilder a5 = new StringBuilder();
   StringBuilder a6 = new StringBuilder();
   // ---------------------------------------------------------------------
   public void test01() {
      StringBuilder[] orig = {a1, a2, a3, a4};
      StringBuilder[] kopi = UebKopiereFlachR.KopiereFlachR(orig);
      assertTrue(istFlacheKopie(orig, kopi));
   } // test01
   // ---------------------------------------------------------------------
   public void test02() {
      StringBuilder[] orig = {a4, a5, a6}; // 3 gleiche Komponenten
      StringBuilder[] kopi = UebKopiereFlachR.KopiereFlachR(orig);
      assertTrue(istFlacheKopie(orig, kopi));
   } // test02
   // ---------------------------------------------------------------------
   public void test03() {
      StringBuilder[] orig = {a4, a4, a4}; // 3 identische Komponenten
      StringBuilder[] kopi = UebKopiereFlachR.KopiereFlachR(orig);
      assertTrue(istFlacheKopie(orig, kopi));
   } // test03
   // ---------------------------------------------------------------------
   public void test04() {
      StringBuilder[] orig = {};
      StringBuilder[] kopi = UebKopiereFlachR.KopiereFlachR(orig);
      assertTrue(istFlacheKopie(orig, kopi));
   } // test04
   // ---------------------------------------------------------------------
   public void test05() {

   } // test05
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      junit.awtui.TestRunner.run(UebKopiereFlachRJut.class);
   } // main
   // ---------------------------------------------------------------------
} // class UebKopiereFlachRJut
